<template>
  <div class="flex items-center col-grow">
    <q-btn
      round
      icon="drag_handle"
      class="editor-field__drag-handle q-mr-sm"
      size="xs"
    />
    <q-input
      v-model="field.label"
      inverted-light
      color="white"
      stack-label="Label"
      class="col-grow"
    />
    <q-input
      v-model="field.width"
      stack-label="Width"
      inverted-light
      color="white"
      suffix="%"
      type="number"
      :min="0"
      :max="100"
      class="q-ml-sm"
    />
    <q-select
      v-model="field.type"
      stack-label="Type"
      inverted-light
      color="white"
      class="q-ml-sm"
      :options="availableTypes"
    />
    <q-select
      v-if="field.type !== 'children'"
      v-model="field.config.field"
      stack-label="Field"
      inverted-light
      color="white"
      class="q-ml-sm"
      :options="availableFields"
    />
    <q-btn
      icon="build"
      color="blue"
      @click="$emit('edit')"
      round
      size="sm"
      class="q-ml-sm"
    />
    <q-btn
      icon="delete"
      color="red"
      @click="$emit('remove')"
      round
      size="sm"
      class="q-ml-sm"
    />
  </div>
</template>

<script>
  import {
    availableCollectionEditorFieldTypes,
    defaultCollectionEditorFieldConfig,
  } from '../../../../../../utilities/migrateConfig';

  export default {
    name: 'field',
    props: {
      field: {
        type: Object,
      },
      availableFields: {
        type: Array,
      },
    },
    created() {
      if (this.field.config === null) {
        this.field.config = defaultCollectionEditorFieldConfig(this.field.type);
      }
    },
    watch: {
      // eslint-disable-next-line func-names
      'field.type': function (type) {
        this.field.config = {
          ...defaultCollectionEditorFieldConfig(type),
          ...(type !== 'children' ? {
            field: (this.field.config || {}).field,
          } : {
            field: null,
          }),
        };
      },
    },
    data() {
      return {
        availableTypes: availableCollectionEditorFieldTypes,
      };
    },
  };
</script>
